searchNodes=[{"doc":"Parse Athena structures and schemas.","ref":"parthenon.html","title":"parthenon","type":"module"},{"doc":"Parse the provided schema and register it in the list of available schemas as the specified name.","ref":"parthenon.html#add_schema/2","title":"parthenon.add_schema/2","type":"function"},{"doc":"Parse the raw Athena structure with the specified schema.","ref":"parthenon.html#decode/2","title":"parthenon.decode/2","type":"function"},{"doc":"Parse the raw Athena structure with the specified schema and apply the specified options. The supported options are: object_format : Specify the format of the objects. maps (default): return objects as maps proplists : return objects as proplists tuple will return objects in the {[{&lt;key&gt;, &lt;value&gt;}]} format key_format : Specify the format of the keys. atom : return the keys as atoms binary will return the keys as binary. existing_atom (default): return the keys as atoms if they already exists or return them into binary if they do not Example usage: %% Register the `point&#39; schema into the registry ok = parthenon : add_schema ( point , &lt;&lt; &quot;struct&lt;x: int, y: int, z: int&gt;&quot; &gt;&gt; ) . %% Register the `coordinates&#39; schema into the registry ok = parthenon : add_schema ( coordinates , &lt;&lt; &quot;array&lt;struct&lt;x: int, y: int, z: int&gt;&gt;&quot; &gt;&gt; ) . %% Decode the `point&#39; structure into a map with binary keys { ok , \#{ &lt;&lt; &quot;x&quot; &gt;&gt; := 3 , &lt;&lt; &quot;y&quot; &gt;&gt; := 2 , &lt;&lt; &quot;z&quot; &gt;&gt; := 4 } } = parthenon : decode ( point , &lt;&lt; &quot;{x=3, y=2, z=4}&quot; &gt;&gt; , [ { key_format , binary } , { object_format , maps } ] ) . %% Decode the `coordinates&#39; array into a list of maps with binary keys { ok , [ \#{ &lt;&lt; &quot;x&quot; &gt;&gt; := 3 , &lt;&lt; &quot;y&quot; &gt;&gt; := 2 , &lt;&lt; &quot;z&quot; &gt;&gt; := 4 } , \#{ &lt;&lt; &quot;x&quot; &gt;&gt; := 5 , &lt;&lt; &quot;y&quot; &gt;&gt; := 6 , &lt;&lt; &quot;z&quot; &gt;&gt; := 7 } ] } = parthenon : decode ( coordinates , &lt;&lt; &quot;[{x=3, y=2, z=4}, {x=5, y=6, z=7}]&quot; &gt;&gt; , [ { key_format , binary } , { object_format , maps } ] ) .","ref":"parthenon.html#decode/3","title":"parthenon.decode/3","type":"function"},{"doc":"","ref":"parthenon_app.html","title":"parthenon_app","type":"module"},{"doc":"","ref":"parthenon_app.html#start/2","title":"parthenon_app.start/2","type":"function"},{"doc":"","ref":"parthenon_app.html#stop/1","title":"parthenon_app.stop/1","type":"function"},{"doc":"","ref":"parthenon_decode.html","title":"parthenon_decode","type":"module"},{"doc":"","ref":"parthenon_decode.html#try_decode/2","title":"parthenon_decode.try_decode/2","type":"function"},{"doc":"","ref":"parthenon_decode.html#try_decode/3","title":"parthenon_decode.try_decode/3","type":"function"},{"doc":"","ref":"parthenon_decode.html#t:array/0","title":"parthenon_decode.array/0","type":"type"},{"doc":"","ref":"parthenon_decode.html#t:decode_options/0","title":"parthenon_decode.decode_options/0","type":"type"},{"doc":"","ref":"parthenon_decode.html#t:key_format/0","title":"parthenon_decode.key_format/0","type":"type"},{"doc":"","ref":"parthenon_decode.html#t:key_type/0","title":"parthenon_decode.key_type/0","type":"type"},{"doc":"","ref":"parthenon_decode.html#t:next/0","title":"parthenon_decode.next/0","type":"type"},{"doc":"","ref":"parthenon_decode.html#t:object/0","title":"parthenon_decode.object/0","type":"type"},{"doc":"","ref":"parthenon_decode.html#t:object_format/0","title":"parthenon_decode.object_format/0","type":"type"},{"doc":"","ref":"parthenon_decode.html#t:option/0","title":"parthenon_decode.option/0","type":"type"},{"doc":"","ref":"parthenon_decode.html#t:schema/0","title":"parthenon_decode.schema/0","type":"type"},{"doc":"","ref":"parthenon_decode.html#t:value/0","title":"parthenon_decode.value/0","type":"type"},{"doc":"","ref":"parthenon_decode.html#t:whitespace_next/0","title":"parthenon_decode.whitespace_next/0","type":"type"},{"doc":"","ref":"parthenon_schema.html","title":"parthenon_schema","type":"module"},{"doc":"","ref":"parthenon_schema.html#create/1","title":"parthenon_schema.create/1","type":"function"},{"doc":"","ref":"parthenon_schema.html#t:encoder/0","title":"parthenon_schema.encoder/0","type":"type"},{"doc":"","ref":"parthenon_schema.html#t:schema/0","title":"parthenon_schema.schema/0","type":"type"},{"doc":"","ref":"parthenon_schema.html#t:schema_key/0","title":"parthenon_schema.schema_key/0","type":"type"},{"doc":"","ref":"parthenon_schema.html#t:schema_object/0","title":"parthenon_schema.schema_object/0","type":"type"},{"doc":"","ref":"parthenon_schema.html#t:schema_value/0","title":"parthenon_schema.schema_value/0","type":"type"},{"doc":"","ref":"parthenon_schema.html#t:supported_types/0","title":"parthenon_schema.supported_types/0","type":"type"},{"doc":"","ref":"parthenon_schema_lexer.html","title":"parthenon_schema_lexer","type":"module"},{"doc":"","ref":"parthenon_schema_lexer.html#format_error/1","title":"parthenon_schema_lexer.format_error/1","type":"function"},{"doc":"","ref":"parthenon_schema_lexer.html#string/1","title":"parthenon_schema_lexer.string/1","type":"function"},{"doc":"","ref":"parthenon_schema_lexer.html#string/2","title":"parthenon_schema_lexer.string/2","type":"function"},{"doc":"","ref":"parthenon_schema_lexer.html#token/2","title":"parthenon_schema_lexer.token/2","type":"function"},{"doc":"","ref":"parthenon_schema_lexer.html#token/3","title":"parthenon_schema_lexer.token/3","type":"function"},{"doc":"","ref":"parthenon_schema_lexer.html#tokens/2","title":"parthenon_schema_lexer.tokens/2","type":"function"},{"doc":"","ref":"parthenon_schema_lexer.html#tokens/3","title":"parthenon_schema_lexer.tokens/3","type":"function"},{"doc":"","ref":"parthenon_schema_lexer.html#word_type/1","title":"parthenon_schema_lexer.word_type/1","type":"function"},{"doc":"","ref":"parthenon_schema_parser.html","title":"parthenon_schema_parser","type":"module"},{"doc":"","ref":"parthenon_schema_parser.html#format_error/1","title":"parthenon_schema_parser.format_error/1","type":"function"},{"doc":"","ref":"parthenon_schema_parser.html#parse/1","title":"parthenon_schema_parser.parse/1","type":"function"},{"doc":"","ref":"parthenon_schema_parser.html#parse_and_scan/1","title":"parthenon_schema_parser.parse_and_scan/1","type":"function"},{"doc":"","ref":"parthenon_schema_parser.html#t:yecc_ret/0","title":"parthenon_schema_parser.yecc_ret/0","type":"type"},{"doc":"","ref":"parthenon_schema_server.html","title":"parthenon_schema_server","type":"module"},{"doc":"","ref":"parthenon_schema_server.html#add_schema/2","title":"parthenon_schema_server.add_schema/2","type":"function"},{"doc":"","ref":"parthenon_schema_server.html#get_schema/1","title":"parthenon_schema_server.get_schema/1","type":"function"},{"doc":"","ref":"parthenon_schema_server.html#handle_call/3","title":"parthenon_schema_server.handle_call/3","type":"function"},{"doc":"","ref":"parthenon_schema_server.html#handle_cast/2","title":"parthenon_schema_server.handle_cast/2","type":"function"},{"doc":"","ref":"parthenon_schema_server.html#handle_info/2","title":"parthenon_schema_server.handle_info/2","type":"function"},{"doc":"","ref":"parthenon_schema_server.html#init/1","title":"parthenon_schema_server.init/1","type":"function"},{"doc":"","ref":"parthenon_schema_server.html#start_link/0","title":"parthenon_schema_server.start_link/0","type":"function"},{"doc":"","ref":"parthenon_schema_server.html#terminate/2","title":"parthenon_schema_server.terminate/2","type":"function"},{"doc":"","ref":"parthenon_sup.html","title":"parthenon_sup","type":"module"},{"doc":"","ref":"parthenon_sup.html#init/1","title":"parthenon_sup.init/1","type":"function"},{"doc":"","ref":"parthenon_sup.html#start_link/0","title":"parthenon_sup.start_link/0","type":"function"},{"doc":"","ref":"parthenon_utils.html","title":"parthenon_utils","type":"module"},{"doc":"","ref":"parthenon_utils.html#lightweight_trim/1","title":"parthenon_utils.lightweight_trim/1","type":"function"},{"doc":"","ref":"parthenon_utils.html#trim/1","title":"parthenon_utils.trim/1","type":"function"},{"doc":"parthenon is an OTP application that parses AWS Athena structures into Erlang terms.","ref":"readme.html","title":"Overview","type":"extras"},{"doc":"Inside rebar.config : %% ... { deps , [ %% ... parthenon ] } . Inside .app.src : %% ... { applications , [ %% ... parthenon ] } , %% ... Inside the code: parthenon : add_schema ( athena_structure , &lt;&lt; &quot;struct&lt;a: int, b: int&gt;&quot; &gt;&gt; ) . parthenon : decode ( athena_structure , &lt;&lt; &quot;{a=123, b=456}&quot; &gt;&gt; ) . { ok , Binary } = file : read_file ( &quot;/path/to/athena-structure-schema&quot; ) . parthenon : add_schema ( athena_structure , Binary ) . { ok , RawStructure } = file : read_file ( &quot;/path/to/raw-athena-structure&quot; ) . parthenon : decode ( athena_structure , RawStructure ) .","ref":"readme.html#usage","title":"Overview - Usage","type":"extras"},{"doc":"Running all the tests and linters You can run all the tests and linters with the rebar3 alias: rebar3 check","ref":"readme.html#development","title":"Overview - Development","type":"extras"},{"doc":"Copyright © 2022 Antoine Gagné All rights reserved. Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met: 1. Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer. 2. Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution. 3. Neither the name of the organization nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission. THIS SOFTWARE IS PROVIDED BY Antoine Gagné ''AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL Antoine Gagné BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.","ref":"license.html","title":"License","type":"extras"}]